package br.com.webpublico.<%=modulo%>.services;

import br.com.webpublico.comum.services.AbstractService;
import br.com.webpublico.comum.services.AbstractServiceTest;
import br.com.webpublico.<%=modulo%>.entities.<%=classe%>;
import br.com.webpublico.comum.entities.EntidadeWebPublico;
import br.com.webpublico.comum.repositories.jpa.AbstractJPARepository;
import br.com.webpublico.<%=modulo%>.repositories.jpa.<%=classe%>JPARepository;
import br.com.webpublico.<%=modulo%>.services.<%=classe%>Service;
import org.junit.Test;
import org.mockito.InjectMocks;
import org.mockito.Mock;

import static br.com.webpublico.comum.utils.TestUtil.randomValue;

public class <%=classe%>ServiceTest extends AbstractServiceTest {

    @InjectMocks
    private <%=classe%>Service sut;

    @Mock
    private <%=classe%>JPARepository repository;

    @Override
    protected AbstractService getSut() {
        return sut;
    }

    @Override
    protected EntidadeWebPublico getEntidadeValida() {
        <%=classe%> retorno = new <%=classe%>();<%for(fieldId in fields) { if(fields[fieldId].annotations.obrigatorio) {%>
        retorno.set<%=fields[fieldId].capitalizedFieldName%>((<%=fields[fieldId].fieldType.type%>)randomValue(<%=fields[fieldId].fieldType.type%>.class, <%=fields[fieldId].fieldType.size ? fields[fieldId].fieldType.size : 'null'%>));<%}}%>
        return retorno;
    }

    @Override
    protected AbstractJPARepository getRepository() {
        return repository;
    }

}
